Attribute VB_Name = "modResFile"
Option Explicit

' DO NOT recommend walking thru any of these enumerator processes. Potential to crash exists
' Note: The Enumxxxx API declarations have been tweaked to allow custom lParam values to be passed/referenced

Public Declare Function EnumResourceTypes Lib "kernel32" Alias "EnumResourceTypesA" (ByVal hModule As Long, ByVal lpEnumFunc As Long, ByRef lParam As Long) As Long
Public Declare Function EnumResourceNamesA Lib "kernel32" (ByVal hModule As Long, ByVal lpType As Long, ByVal lpEnumFunc As Long, ByRef lParam As Any) As Long
Public Declare Function EnumResourceNamesW Lib "kernel32" (ByVal hModule As Long, ByVal lpType As Long, ByVal lpEnumFunc As Long, ByRef lParam As Any) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

Public Function EnumResTypesProc(ByVal hMod As Long, ByVal lpszType As Long, ByRef lParam As Long) As Long
   ' called to enumerate types of resources
   If (lpszType And &HFFFF0000) = 0& Then
      ' the lParam is set by the calling routine and is the resource type we are looking for
      If (lpszType And &HFFFF&) = lParam Then
            lParam = 0&     ' found, stop enumerating
            Exit Function
      End If
   End If
   EnumResTypesProc = 1&
   
End Function

Public Function EnumResNamesProcA(ByVal hMod As Long, ByVal lpszType As Long, ByVal lpszName As Long, ByRef lParam As Collection) As Long
    ' ANSI version. Called to retrieve resource IDs
    ' Note: lParam modified, this function will expect a collection object
    Dim b() As Byte
    Dim lLen As Long

    If (lpszName And &HFFFF0000) = 0& Then  ' numeric ID
         lParam.Add "#" & CStr(lpszName And &HFFFF&)  ' add to our collection
    Else
         lLen = lstrlen(lpszName)           ' string ID
         If (lLen > 0) Then
             ReDim b(0 To lLen - 1&)
             CopyMemory b(0), ByVal lpszName, lLen
             lParam.Add StrConv(b, vbUnicode) ' add to our collection
         End If
    End If
    EnumResNamesProcA = 1&

End Function

Public Function EnumResNamesProcW(ByVal hMod As Long, ByVal lpszType As Long, ByVal lpszName As Long, ByRef lParam As Collection) As Long
    ' UNICODE version. Called to retrieve resource IDs
    ' Note: lParam modified, this function will expect a collection object
    Dim sName As String
    Dim lLen As Long

   If (lpszName And &HFFFF0000) = 0 Then    ' numeric ID
        lParam.Add "#" & CStr(lpszName And &HFFFF&)   ' add to our collection
   Else
        lLen = lstrlenW(lpszName)           ' string ID
        If (lLen > 0) Then
            sName = String$(lLen \ 2, vbNullChar)
            CopyMemory ByVal StrPtr(sName), ByVal lpszName, lLen
            lParam.Add sName                ' add to our collection
        End If
   End If
   EnumResNamesProcW = 1&
End Function

